/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.foundation.data_types.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import fr.obeo.acceleo.uml13.foundation.data_types.ActionExpression;
import fr.obeo.acceleo.uml13.foundation.data_types.ArgListsExpression;
import fr.obeo.acceleo.uml13.foundation.data_types.BooleanExpression;
import fr.obeo.acceleo.uml13.foundation.data_types.Data_typesPackage;
import fr.obeo.acceleo.uml13.foundation.data_types.Expression;
import fr.obeo.acceleo.uml13.foundation.data_types.IterationExpression;
import fr.obeo.acceleo.uml13.foundation.data_types.MappingExpression;
import fr.obeo.acceleo.uml13.foundation.data_types.Multiplicity;
import fr.obeo.acceleo.uml13.foundation.data_types.MultiplicityRange;
import fr.obeo.acceleo.uml13.foundation.data_types.ObjectSetExpression;
import fr.obeo.acceleo.uml13.foundation.data_types.ProcedureExpression;
import fr.obeo.acceleo.uml13.foundation.data_types.TimeExpression;
import fr.obeo.acceleo.uml13.foundation.data_types.TypeExpression;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It
 * provides an adapter <code>createXXX</code> method for each class of the
 * model. <!-- end-user-doc -->
 * 
 * @see fr.obeo.acceleo.uml13.foundation.data_types.Data_typesPackage
 * @generated
 */
public class Data_typesAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static Data_typesPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public Data_typesAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = Data_typesPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc --> This implementation returns <code>true</code>
	 * if the object is either the model's package or is an instance object of
	 * the model. <!-- end-user-doc -->
	 * 
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject) object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected Data_typesSwitch modelSwitch = new Data_typesSwitch() {
		public Object caseMultiplicity(Multiplicity object) {
			return createMultiplicityAdapter();
		}

		public Object caseMultiplicityRange(MultiplicityRange object) {
			return createMultiplicityRangeAdapter();
		}

		public Object caseExpression(Expression object) {
			return createExpressionAdapter();
		}

		public Object caseObjectSetExpression(ObjectSetExpression object) {
			return createObjectSetExpressionAdapter();
		}

		public Object caseTimeExpression(TimeExpression object) {
			return createTimeExpressionAdapter();
		}

		public Object caseBooleanExpression(BooleanExpression object) {
			return createBooleanExpressionAdapter();
		}

		public Object caseActionExpression(ActionExpression object) {
			return createActionExpressionAdapter();
		}

		public Object caseIterationExpression(IterationExpression object) {
			return createIterationExpressionAdapter();
		}

		public Object caseTypeExpression(TypeExpression object) {
			return createTypeExpressionAdapter();
		}

		public Object caseArgListsExpression(ArgListsExpression object) {
			return createArgListsExpressionAdapter();
		}

		public Object caseMappingExpression(MappingExpression object) {
			return createMappingExpressionAdapter();
		}

		public Object caseProcedureExpression(ProcedureExpression object) {
			return createProcedureExpressionAdapter();
		}

		public Object defaultCase(EObject object) {
			return createEObjectAdapter();
		}
	};

	/**
	 * Creates an adapter for the <code>target</code>. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @param target
	 *            the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	public Adapter createAdapter(Notifier target) {
		return (Adapter) modelSwitch.doSwitch((EObject) target);
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.Multiplicity
	 * <em>Multiplicity</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.Multiplicity
	 * @generated
	 */
	public Adapter createMultiplicityAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.MultiplicityRange
	 * <em>Multiplicity Range</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.MultiplicityRange
	 * @generated
	 */
	public Adapter createMultiplicityRangeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.Expression
	 * <em>Expression</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.Expression
	 * @generated
	 */
	public Adapter createExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.ObjectSetExpression
	 * <em>Object Set Expression</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.ObjectSetExpression
	 * @generated
	 */
	public Adapter createObjectSetExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.TimeExpression
	 * <em>Time Expression</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.TimeExpression
	 * @generated
	 */
	public Adapter createTimeExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.BooleanExpression
	 * <em>Boolean Expression</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.BooleanExpression
	 * @generated
	 */
	public Adapter createBooleanExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.ActionExpression
	 * <em>Action Expression</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.ActionExpression
	 * @generated
	 */
	public Adapter createActionExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.IterationExpression
	 * <em>Iteration Expression</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.IterationExpression
	 * @generated
	 */
	public Adapter createIterationExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.TypeExpression
	 * <em>Type Expression</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.TypeExpression
	 * @generated
	 */
	public Adapter createTypeExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.ArgListsExpression
	 * <em>Arg Lists Expression</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.ArgListsExpression
	 * @generated
	 */
	public Adapter createArgListsExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.MappingExpression
	 * <em>Mapping Expression</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.MappingExpression
	 * @generated
	 */
	public Adapter createMappingExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link fr.obeo.acceleo.uml13.foundation.data_types.ProcedureExpression
	 * <em>Procedure Expression</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml13.foundation.data_types.ProcedureExpression
	 * @generated
	 */
	public Adapter createProcedureExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case. <!-- begin-user-doc --> This
	 * default implementation returns null. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} // Data_typesAdapterFactory
