/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.common_behavior;

import org.eclipse.emf.common.util.EList;

import fr.obeo.acceleo.uml14.foundation.core.Classifier;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Signal</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Signal#getReception
 * <em>Reception</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Signal#getContext
 * <em>Context</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Signal#getSendAction
 * <em>Send Action</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Signal#getOccurrence
 * <em>Occurrence</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage#getSignal()
 * @model
 * @generated
 */
public interface Signal extends Classifier {
	/**
	 * Returns the value of the '<em><b>Reception</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Reception} .
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Reception#getSignal
	 * <em>Signal</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reception</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Reception</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage#getSignal_Reception()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Reception#getSignal
	 * @model type=
	 *        "fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Reception"
	 *        opposite="signal"
	 * @generated
	 */
	EList getReception();

	/**
	 * Returns the value of the '<em><b>Context</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.foundation.core.BehavioralFeature}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.foundation.core.BehavioralFeature#getRaisedSignal
	 * <em>Raised Signal</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Context</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Context</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage#getSignal_Context()
	 * @see fr.obeo.acceleo.uml14.foundation.core.BehavioralFeature#getRaisedSignal
	 * @model type="fr.obeo.acceleo.uml14.foundation.core.BehavioralFeature"
	 *        opposite="raisedSignal"
	 * @generated
	 */
	EList getContext();

	/**
	 * Returns the value of the '<em><b>Send Action</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.SendAction} .
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.SendAction#getSignal
	 * <em>Signal</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Send Action</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Send Action</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage#getSignal_SendAction()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.SendAction#getSignal
	 * @model type=
	 *        "fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.SendAction"
	 *        opposite="signal"
	 * @generated
	 */
	EList getSendAction();

	/**
	 * Returns the value of the '<em><b>Occurrence</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SignalEvent} .
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SignalEvent#getSignal
	 * <em>Signal</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Occurrence</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Occurrence</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage#getSignal_Occurrence()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SignalEvent#getSignal
	 * @model type=
	 *        "fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SignalEvent"
	 *        opposite="signal"
	 * @generated
	 */
	EList getOccurrence();

} // Signal
