/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.acceleo.template.core.impl;

import org.acceleo.template.core.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class CoreFactoryImpl extends EFactoryImpl implements CoreFactory {
	/**
	 * Creates the default factory implementation. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static CoreFactory init() {
		try {
			CoreFactory theCoreFactory = (CoreFactory) EPackage.Registry.INSTANCE.getEFactory("http://www.obeo.fr/acceleo/template/3.0.0/core");
			if (theCoreFactory != null) {
				return theCoreFactory;
			}
		} catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new CoreFactoryImpl();
	}

	/**
	 * Creates an instance of the factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public CoreFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
		case CorePackage.TEMPLATE:
			return createTemplate();
		case CorePackage.SCRIPT:
			return createScript();
		case CorePackage.SCRIPT_DESCRIPTOR:
			return createScriptDescriptor();
		case CorePackage.FILE_PATH:
			return createFilePath();
		case CorePackage.METAMODEL:
			return createMetamodel();
		case CorePackage.SERVICE:
			return createService();
		case CorePackage.METHOD:
			return createMethod();
		case CorePackage.PARAMETER:
			return createParameter();
		default:
			throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	private static Class<?> templateClass;

	public Template createTemplate() {
		Template template = null;
		if (templateClass == null) {
			try {
				templateClass = Class.forName("org.acceleo.engine.template.core.impl.spec.TTemplate"); //$NON-NLS-1$
			} catch (Exception e) {
				templateClass = TemplateImpl.class;
			}
		}
		try {
			template = (Template) templateClass.newInstance();
		} catch (InstantiationException e) {
			// impossible
		} catch (IllegalAccessException e) {
			// impossible
		}
		return template;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	private static Class<?> scriptClass;

	public Script createScript() {
		Script script = null;
		if (scriptClass == null) {
			try {
				scriptClass = Class.forName("org.acceleo.engine.template.core.impl.spec.TScript"); //$NON-NLS-1$
			} catch (Exception e) {
				scriptClass = ScriptImpl.class;
			}
		}
		try {
			script = (Script) scriptClass.newInstance();
		} catch (InstantiationException e) {
			// impossible
		} catch (IllegalAccessException e) {
			// impossible
		}
		return script;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ScriptDescriptor createScriptDescriptor() {
		ScriptDescriptorImpl scriptDescriptor = new ScriptDescriptorImpl();
		return scriptDescriptor;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	private static Class<?> filePathClass;

	public FilePath createFilePath() {
		FilePath filePath = null;
		if (filePathClass == null) {
			try {
				filePathClass = Class.forName("org.acceleo.engine.template.core.impl.spec.TFilePath"); //$NON-NLS-1$
			} catch (Exception e) {
				filePathClass = FilePathImpl.class;
			}
		}
		try {
			filePath = (FilePath) filePathClass.newInstance();
		} catch (InstantiationException e) {
			// impossible
		} catch (IllegalAccessException e) {
			// impossible
		}
		return filePath;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Metamodel createMetamodel() {
		MetamodelImpl metamodel = new MetamodelImpl();
		return metamodel;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	private static Class<?> serviceClass;
	public Service createService() {
		Service service = null;
		if (serviceClass == null) {
			try {
				serviceClass = Class.forName("org.acceleo.engine.template.core.impl.spec.TService"); //$NON-NLS-1$
			} catch (Exception e) {
				serviceClass = ServiceImpl.class;
			}
		}
		try {
			service = (Service) serviceClass.newInstance();
		} catch (InstantiationException e) {
			// impossible
		} catch (IllegalAccessException e) {
			// impossible
		}
		return service;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Method createMethod() {
		MethodImpl method = new MethodImpl();
		return method;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Parameter createParameter() {
		ParameterImpl parameter = new ParameterImpl();
		return parameter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public CorePackage getCorePackage() {
		return (CorePackage) getEPackage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static CorePackage getPackage() {
		return CorePackage.eINSTANCE;
	}

} // CoreFactoryImpl
